vector<pt> convexHull(vector<pt> pts) {
    if (pts.size() <= 1) return pts;
    sort(all(pts));
    vector<pt> h(pts.size()+1);
    int s = 0, t = 0;
    for(int it = 2; it--; s = --t, reverse(all(pts)))
        for(pt p : pts) {
            while(t>=s+2 && ccw(h[t-2],h[t-1],p) <= 0) t--;
            h[t++] = p;
        }
    return {h.begin(),h.begin()+t - (t==2 && h[0] == h[1])};
}